﻿using System;
using System.Collections.Generic;
using System.Web;
using System.Web.Services;
#region 命名空间

using Newtonsoft.Json;

#endregion

namespace WebService
{
    /// <summary>
    /// PersonalServices 的摘要说明
    /// </summary>
    [WebService(Namespace = "http://tempuri.org/")]
    [WebServiceBinding(ConformsTo = WsiProfiles.BasicProfile1_1)]
    [System.ComponentModel.ToolboxItem(false)]
    public class PersonalServices : System.Web.Services.WebService
    {
        #region 获取用户信息

        [WebMethod]
        public void GetUserList(string userName)
        {
            List<Personal> m_PersonalList = new List<Personal>();
            string[] strArr = userName.Split(',');
            foreach (string item in strArr)
            {
                Personal m_Personal = GetUserByName(item);
                if (m_Personal != null)
                {
                    m_PersonalList.Add(m_Personal);
                }
            }
            ResponseResult responseResult = new ResponseResult();
            if (m_PersonalList.Count == 0)
            {
                responseResult.ResponseDetails = "没有查到该用户！";
                responseResult.ResponseStatus = 0;
            }
            else
            {
                responseResult.ResponseData = m_PersonalList;
                responseResult.ResponseDetails = "查询用户信息成功！";
                responseResult.ResponseStatus = 1;
            }
            string jsoncallback = HttpContext.Current.Request["jsoncallback"];
            //返回数据的方式
            //  其中将泛型集合使用了Json库(第三方序列json数据的dll)转变成json数据字符串
            string result = jsoncallback + "(" + JsonConvert.SerializeObject(responseResult, Formatting.Indented) + ")";
            HttpContext.Current.Response.Write(result);
            HttpContext.Current.Response.End();
        }

        #endregion

        #region 模拟数据库处理结果

        /// <summary>
        /// 根据用户名查询用户
        /// </summary>
        /// <param name="userName">用户名</param>
        /// <returns></returns>
        Personal GetUserByName(string userName)
        {
            List<Personal> m_PersonalList = new List<Personal>();
            m_PersonalList.Add(new Personal()
            {
                Id = "01",
                Name = "liger_zql",
                Sex = "男",
                Age = 21,
                Remark = "你猜......"
            });
            m_PersonalList.Add(new Personal()
            {
                Id = "02",
                Name = "漠然",
                Sex = "女",
                Age = 22,
                Remark = "猜不透......"
            });
            foreach (Personal m_Personal in m_PersonalList)
            {
                if (m_Personal.Name == userName)
                {
                    return m_Personal;
                }
            }
            return null;
        }

        #endregion

        #region json数据序列化所需类

        /// <summary>
        /// 处理信息类
        ///     ResponseData--输出处理数据
        ///     ResponseDetails--处理详细信息
        ///     ResponseStatus--处理状态
        ///         -1=失败,0=没有获取数据,1=处理成功！
        /// </summary>
        class ResponseResult
        {
            public List<Personal> ResponseData { get; set; }
            public string ResponseDetails { get; set; }
            public int ResponseStatus { get; set; }
        }

        /// <summary>
        /// 用户信息类
        /// </summary>
        class Personal
        {
            public string Id { get; set; }
            public string Name { get; set; }
            public int Age { get; set; }
            public string Sex { get; set; }
            public string Remark { get; set; }
        }

        #endregion
    }
}
